//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <vcl\inifiles.hpp>
#include <vcl\clipbrd.hpp>
#pragma hdrstop

#include "SpendDlgs2.h"
#include "HashCashDlgs.h"
#include "utct.h"
#include "global.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TSpendDlg2 *SpendDlg2;
//---------------------------------------------------------------------------
bool __fastcall SpendToken2(TForm *Owner, int bits, AnsiString resource)
{
   SpendDlg2 = new TSpendDlg2(Owner);
   SpendDlg2->resource = resource;   // not used
   SpendDlg2->bits = bits;           // not used
   if (SpendDlg2->GetAToken()) SpendDlg2->ShowModal();
   bool ok = SpendDlg2->ok;
   delete SpendDlg2;
   return ok;
}
//---------------------------------------------------------------------------
__fastcall TSpendDlg2::TSpendDlg2(TComponent* Owner)
	: TForm(Owner)
{
   tokens = new TStringList();
   bits = 0; resource = "";
   ok = false;
}
//---------------------------------------------------------------------------
__fastcall TSpendDlg2::~TSpendDlg2()
{
   delete tokens;
}
//---------------------------------------------------------------------------
int __fastcall TSpendDlg2::ValidField(int pos, AnsiString &expiretime)
{
   if (pos>=0 && pos<4) return GetToken(pos,expiretime,":").ToIntDef(0);
   return 0;
}
//---------------------------------------------------------------------------
int __fastcall TSpendDlg2::ValidTimeInSeconds(AnsiString &validperiod)
{
   AnsiString v=validperiod.LowerCase();
   if (!v.IsEmpty() && v.Pos("s")==v.Length())
      return v.SubString(1,v.Length()-1).ToIntDef(0);
   return (86400*ValidField(0,v))+(3600*ValidField(1,v))+(60*ValidField(2,v))+ValidField(3,v);
}
//---------------------------------------------------------------------------
int __fastcall TSpendDlg2::TokenStatus(AnsiString &token)
{
   char token_utime[MAX_UTC];
   char token_resource[MAX_RES];
   hashcash_parse(token.c_str(),token_utime,MAX_UTC,token_resource,MAX_RES);
   time_t token_time = from_utctimestr(token_utime);
   time_t nowtime = local_to_utctime(time(NULL));
   return hashcash_valid_for(token_time,ValidTimeInSeconds(validperiod),nowtime);
}
//---------------------------------------------------------------------------
bool __fastcall TSpendDlg2::GetAToken()
{
   AnsiString xhashcash;
   TIniFile *ini = new TIniFile(AppIni);
   xhashcash = ini->ReadString("main","xhashcash","X-Hashcash:").Trim()+" ";
   validperiod = ini->ReadString("main","expires","0");
   delete ini;

   ok = true;
   int i,item,count,result;
   if (hWndHCW && (result=SendMessage(hWndHCW,WM_SPENDTOKEN,0,0))>0)
   {

      count = HIWORD(result); item = LOWORD(result);
      if (item==65535) goto errs;
      Caption = "Spending 1 of "+s(count);
      return ok;
   }
   LoadTokenPool(tokens);
   count = tokens->Count;
   i=-1; while(++i<tokens->Count)
   {
      token = tokens->Strings[i];
      int stat=TokenStatus(token);
      if (stat==HASHCASH_EXPIRED || stat==HASHCASH_VALID_IN_FUTURE) continue;

      Caption = "Spending 1 of "+s(tokens->Count);//s(i+1)+" of "+s(tokens->Count);
      Clipboard()->AsText = xhashcash+" "+token;
      tokens->Delete(i);
      SaveTokenPool(tokens);
      return ok;
   }

errs:
   if (count)
   {
      MsgBoxTsk(
         s("Your remaining tokens are all valid in the future, so none are available\n")+
         s("for spending now! You'll need to mint some before continuing."),
         s("HashCash Mint"),MB_OK);
   }
   else
   {
      MsgBoxTsk(
         s("There are no tokens left for spending! You'll need to mint\n")+
         s("some before continuing."),
         s("HashCash Mint"),MB_OK);
   }
   ModalResult = mrCancel;
   ok = false;
   return ok;
}
//---------------------------------------------------------------------------
//int __fastcall TSpendDlg2::GetBits(AnsiString token)
//{
//   return GetToken(0,token,":").ToIntDef(0);
//}
//---------------------------------------------------------------------------
//AnsiString __fastcall TSpendDlg2::GetResource(AnsiString token)
//{
//   return GetToken(2,token,":");
//}
//---------------------------------------------------------------------------
void __fastcall TSpendDlg2::FormShow(TObject *Sender)
{
   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TSpendDlg2::Timer1Timer(TObject *Sender)
{
   Timer1->Enabled = false;
   ModalResult = mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TSpendDlg2::LoadTokenPool(TStrings *tokens)
{
   if (FileExists(AppQue)) tokens->LoadFromFile(AppQue);
   else tokens->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TSpendDlg2::SaveTokenPool(TStrings *tokens)
{
   //the lock file is created in THashCashDlg
   tokens->SaveToFile(AppQue);
}
//---------------------------------------------------------------------------
void __fastcall TSpendDlg2::FormCloseQuery(TObject *Sender, bool &CanClose)
{
//   if (ModalResult==mrCancel)
//      ok = false;
}
//---------------------------------------------------------------------------
